summaryrefslogtreecommitdiffstats
path: root/system/wine/wine.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/wine/wine.SlackBuild')
-rw-r--r--system/wine/wine.SlackBuild257
1 files changed, 150 insertions, 107 deletions
diff --git a/system/wine/wine.SlackBuild b/system/wine/wine.SlackBuild
index 69f93edf23..7cc898ef39 100644
--- a/system/wine/wine.SlackBuild
+++ b/system/wine/wine.SlackBuild
@@ -1,7 +1,8 @@
-#!/bin/sh
+#!/bin/bash
# Slackware build script for wine
+# Copyright 2023-2024 Steven Voges <Oregon, USA>
# Copyright 2011 David Woodfall
# Copyright 2006-2009 Robby Workman Northport, AL, USA
# All rights reserved.
@@ -23,59 +24,81 @@
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+cd $(dirname $0) ; CWD=$(pwd)
+
PRGNAM=wine
-VERSION=${VERSION:-5.0.2}
-BUILD=${BUILD:-1}
+VERSION=${VERSION:-9.0}
+ARCHS="i386,x86_64"
+BUILD=${BUILD:-3}
TAG=${TAG:-_SBo}
-CWD=$(pwd)
+PKGTYPE=${PKGTYPE:-tgz}
+
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
-WIN32=${WIN32:-yes}
-WIN64=${WIN64:-no}
-# If your video card does not support hardware accelerated OpenGL,
-# then run the script like: OPENGL=NO ./wine.SlackBuild
-if [ "${OPENGL:-yes}" = "yes" ]; then
- do_opengl="with"
-else
- do_opengl="without"
+if [ -z "$ARCH" ]; then
+ case "$(uname -m)" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$(uname -m) ;;
+ esac
fi
-if [ -z "$ARCH" ]; then
- case "$(uname -m)" in
- i?86) ARCH=i586 ;;
- arm*) ARCH=arm ;;
- *) ARCH=$(uname -m) ;;
- esac
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
fi
-if [ "$WIN32" = "no" ] && [ "$WIN64" = "no" ]; then
- echo "Both 64 and 32 bit builds disabled. Nothing to do."
- exit 1
+OPENGL=${OPENGL@L}
+if [ "${OPENGL:-yes}" = "yes" ]; then
+ do_opengl="with"
+else
+ do_opengl="without"
fi
-# These should work for anything not specified below
-BUILD_ARCH=$ARCH"-slackware-linux"
+BUILD_ARCH="$ARCH-slackware-linux"
SLKCFLAGS="-O2"
case "$ARCH" in
- arm)
- BUILD_ARCH=$ARCH"-slackware-linux-gnueabi"
- ;;
- i?86)
- # -Os was -O2, fix for:
- # https://bugs.winehq.org/show_bug.cgi?id=42406
- # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78911
- # https://bugs.gentoo.org/613128
- SLKCFLAGS="-Os -march=$ARCH -mtune=i686"
- ;;
- x86_64)
- SLKCFLAGS="-O2 -fPIC"
- LIBDIRSUFFIX="64"
- ;;
+ arm)
+ BUILD_ARCH="$ARCH-slackware-linux-gnueabi"
+ ;;
+ i?86)
+ # -Os was -O2, fix for:
+ # https://bugs.winehq.org/show_bug.cgi?id=42406
+ # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78911
+ # https://bugs.gentoo.org/613128
+ SLKCFLAGS="-Os -march=$ARCH -mtune=i686"
+ WINE32="yes"
+ ;;
+ x86_64)
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+ WINE64="yes"
+ ;;
esac
+MULTILIB=${MULTILIB@L}
+if [[ "$ARCH" != "x86_64" && "$MULTILIB" = "yes" ]]; then
+ echo "Cannot build for multilib on non-64bit systems."
+ exit 1
+elif [[ "$ARCH" = "x86_64" && "$MULTILIB" = "yes" ]]; then
+ WINETMP="$( mktemp -d $TMP/wine-test-XXXXXX )"
+ echo "int main(void) {; return(0); }" > "$WINETMP/test.c"
+ gcc -m32 "$WINETMP/test.c" -o /dev/null >/dev/null 2>&1 && WINE32TEST=${WINE32TEST:-yes}
+ rm -rf "$WINETMP"
+ if [[ $WINE32TEST = "yes" ]]; then
+ ARCHS="x86_64"
+ WINE32="yes"
+ else
+ echo "MULTILIB was requested, however the multilib test has failed."
+ echo "Have the compat32 libraries been installed?"
+ echo "Please see README.MULTILIB"
+ exit 1
+ fi
+fi
+
set -e
rm -rf $PKG
@@ -86,87 +109,107 @@ tar xvf $CWD/$PRGNAM-$VERSION.tar.xz
cd $PRGNAM-$VERSION
chown -R root:root .
find -L . \
- \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
- -o -perm 511 \) -exec chmod 755 {} \; -o \
- \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
- -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
# Fix for flex
-patch -p1 --verbose < $CWD/0001-winhlp32-Workaround-a-bug-in-Flex.patch
-
-# Remove -fPIC for i?86 or the build will hang
-if [ "$ARCH" == "i?86" ]; then
- patch -p1 --verbose < $CWD/x86_remove_fpic.patch
+patch -p1 --verbose < $CWD/flex.patch
+# WriteCopy Fix
+patch -p1 < $CWD/writecopy.patch
+# Fix path of opencl headers.
+sed 's|OpenCL/opencl.h|CL/opencl.h|g' -i configure*
+
+if [ "$WINE64" = "yes" ]; then
+ wine64="--with-wine64=../wine64"
+ mkdir wine64
+ cd wine64
+
+ LDFLAGS="-L/usr/lib64 -ldl" \
+ CFLAGS="$SLKCFLAGS" \
+ CXXFLAGS="$SLKCFLAGS" \
+ ../configure \
+ --prefix=/usr \
+ --libdir=/usr/lib64 \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --mandir=/usr/man \
+ --enable-win64 \
+ --enable-archs=$ARCHS \
+ --with-x \
+ --with-gnutls \
+ --${do_opengl}-opengl \
+ --program-prefix= \
+ --program-suffix= \
+ --disable-tests \
+ --build=$BUILD_ARCH
+ make depend
+ make
+ make install DESTDIR=$PKG
+ cd ..
fi
-if [ "$WIN64" = "yes" ]; then
- wine64="--with-wine64=../wine64"
- mkdir wine64
- cd wine64
-
- LDFLAGS="-L/usr/lib64 -ldl" \
- CFLAGS="$SLKCFLAGS" \
- CXXFLAGS="$SLKCFLAGS" \
- ../configure \
- --prefix=/usr \
- --libdir=/usr/lib64 \
- --localstatedir=/var \
- --sysconfdir=/etc \
- --mandir=/usr/man \
- --enable-win64 \
- --with-x \
- --with-gnutls \
- --${do_opengl}-opengl \
- --program-prefix= \
- --program-suffix= \
- --disable-tests \
- --build=$BUILD_ARCH
-
- make depend
- make
- make install DESTDIR=$PKG
- cd ..
-fi
-
-
-if [ "$WIN32" = "yes" ]; then
- mkdir wine32
- cd wine32
-
- export PKG_CONFIG_PATH="/usr/lib/pkgconfig:$PKG_CONFIG_PATH"
-
- LDFLAGS="-L/usr/lib -ldl" \
- CFLAGS="$SLKCFLAGS" \
- CXXFLAGS="$SLKCFLAGS" \
- ../configure \
- $wine64 \
- --prefix=/usr \
- --libdir=/usr/lib \
- --localstatedir=/var \
- --sysconfdir=/etc \
- --mandir=/usr/man \
- --with-x \
- --with-gnutls \
- --${do_opengl}-opengl \
- --program-prefix= \
- --program-suffix= \
- --disable-tests \
- --build=$BUILD_ARCH
-
- make depend
- make
- make install DESTDIR=$PKG
- cd ..
+if [ "$WINE32" = "yes" ]; then
+ mkdir wine32
+ cd wine32
+ export PKG_CONFIG_PATH="/usr/lib/pkgconfig:$PKG_CONFIG_PATH"
+
+ LDFLAGS="-L/usr/lib -ldl" \
+ CFLAGS="$SLKCFLAGS" \
+ CXXFLAGS="$SLKCFLAGS" \
+ ../configure \
+ $wine64 \
+ --prefix=/usr \
+ --libdir=/usr/lib \
+ --localstatedir=/var \
+ --sysconfdir=/etc \
+ --mandir=/usr/man \
+ --with-x \
+ --with-gnutls \
+ --${do_opengl}-opengl \
+ --program-prefix=testpre32 \
+ --program-suffix=testsuf32 \
+ --disable-tests \
+ --build=$BUILD_ARCH
+ make depend
+ make
+ make install DESTDIR=$PKG
+ cd ..
fi
find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
- | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
find $PKG/usr/man -type f -exec gzip -9 {} \;
for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+# Add font configuration:
+install -d $PKG/etc/fonts/conf.{avail,d}
+install -m644 $CWD/30-win32-aliases.conf $PKG/etc/fonts/conf.avail
+ln -sf /etc/fonts/conf.avail/30-win32-aliases.conf $PKG/etc/fonts/conf.d/30-win32-aliases.conf
+install -Dm 644 $CWD/wine-binfmt.conf $PKG/usr/lib$LIBDIRSUFFIX/binfmt.d/wine.conf
+
+# Create Wine menu structure:
+mkdir -p $PKG/etc/xdg/menus/applications-merged
+cp $CWD/wine.menu $PKG/etc/xdg/menus/applications-merged
+
+# Add a desktop menu for winecfg, wine-uninstaller and wine-browsedrive:
+mkdir -p $PKG/usr/share/{applications,icons/hicolor/scalable/apps,pixmaps}
+
+convert $CWD/wine.svg -scale 64 $PKG/usr/share/pixmaps/wine.png
+cp $CWD/wine.svg $PKG/usr/share/icons/hicolor/scalable/apps/
+
+convert $CWD/winecfg.png -scale 64 $PKG/usr/share/pixmaps/winecfg.png
+convert $CWD/winecfg.png -scale 64 $PKG/usr/share/pixmaps/folder-wine.png
+convert $CWD/winecfg.png -scale 64 $PKG/usr/share/pixmaps/wine-uninstaller.png
+
+cp programs/winecfg/winecfg.svg $PKG/usr/share/icons/hicolor/scalable/apps/
+cp $CWD/*.desktop $PKG/usr/share/applications/
+
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a ANNOUNCE AUTHORS COPYING.LIB LICENSE* README VERSION $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a ANNOUNCE.md AUTHORS COPYING.* LICENSE* README.md VERSION \
+ $PKG/usr/doc/$PRGNAM-$VERSION
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
mkdir -p $PKG/install
@@ -174,4 +217,4 @@ cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh
cd $PKG
-/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE